% make rotational invariant features
%
% The whole procedure goes like:
% 1. readcells.m       -> cells.mat
% 1a. scalecellimage   -> cellscaled.mat
% 2. gencellgabor.m    -> cells_gabor_sc.mat
% 3. makerotinv
% 3a. gencellsimple.m (max)  -> cellssimplemax.mat
% 3b. gencellsimple.m (mean) -> cellssimplemean.mat
% 3c. gencellsimple.m (var)  -> cellssimplevar.mat

[a,b]=gencellsimple(x,z,'max');
xnew = sumgabororientations(a);
znew = sumgabororientations(b);
[a,b]=gencellsimple(x,z,'mean');
xnew = [xnew sumgabororientations(a)];
znew = [znew sumgabororientations(b)];
[a,b]=gencellsimple(x,z,'var');
xnew = [xnew sumgabororientations(a)];
znew = [znew sumgabororientations(b)];

% fix a wrong labeling in the training set:
lab = getlabels(xnew);
I = strmatch('centromeric',lab);
lab(I,:) = repmat('centromere     ',length(I),1);
xnew = remclass(setlabels(xnew,lab));

a = xnew; b = znew;
save cellssimple_rotinv a b;



